<?
////////////////////////////////////
//////////// Catalogue and shop API
////////////////////////////////////


$catconfig=rcms_parse_ini_file(CONFIG_PATH.'fncatalogue.ini');

 function fn_show_cat_list() {
        $result='<table width="100%"  border="0">';
        $query="SELECT * from `itemcat`";
        $allcats=simple_queryall($query);

        if (!empty($allcats)) {
             $result.='
                    <tr class="row1">
                    <td>'.__('ID').'</td>
                    <td>'.__('Title').'</td>
                    <td>'.__('Description').'</td>
                    <td>'.__('Actions').'</td>
                    </tr>';
            foreach ($allcats as $io=>$eachcat) {
                $result.='
                    <tr class="row2">
                    <td>'.$eachcat['id'].'</td>
                    <td>'.$eachcat['name'].'</td>
                    <td>'.$eachcat['desc'].'</td>
                    <td>
                    <a href="?module=fncatman&deletecat='.$eachcat['id'].'"><img src="skins/fastnews/trash_small.gif" title="'.__('Delete').'" border="0"></a>
                    <a href="?module=fncatman&editcat='.$eachcat['id'].'"><img src="skins/fastnews/edit_small.gif" title="'.__('Edit').'" border="0"></a>
                    </td>
                    </tr>';
            }
            $result.='</table>';
            show_window(__('Item categories'), $result);
        } else {
            show_window('',__('No item categories available'));
        }
    }


    function fn_create_cat_category($name,$desc) {
         $name=mysql_real_escape_string(strip_tags($name));
         $desc=mysql_real_escape_string(strip_tags($desc));
     $query="
         INSERT INTO `itemcat` (
        `id` ,
        `name` ,
        `desc` )
        VALUES (
        NULL , '".$name."', '".$desc."'
        );
        ";
     nr_query($query);
     show_window(__('Result'),__('Category created'));
    }


    function fn_delete_cat_category($id) {
        $query="DELETE FROM `itemcat` WHERE `id`=".$id;
        nr_query($query);
        show_window(__('Result'),__('Category deleted'));
    }

    function fn_show_cat_catadd_form() {
        $form='
            <form action="?module=fncatman&control=categ" method="POST">
            <input type="text" name="newcatname">   '.__('Title').'<sup>*</sup><br>
            <input type="text" name="newcatdesc">  '.__('Description').' <br>
            <input type="submit" value="'.__('Add').'">
            </form>
            ';
        show_window(__('Add category'), $form);
    }

    function fn_cat_catselect() {
        $query="SELECT `id`,`name` from `itemcat`";
        $allcats=simple_queryall($query);
        $result='<select name="catsel">';
        if (!empty ($allcats)) {
        foreach ($allcats as $io=>$eachcat) {
              $result.='<option value="'.$eachcat['id'].'" >'.$eachcat['name'].'</option>';
            }
        }

        $result.='</select>';
        return($result);
    }


    function fn_catman_show_controls() {
     if (fncfr()) {
     $controls='
         <a href="?module=fncatman&control=items">'.__('Items').'</a> |
         <a href="?module=fncatman&control=categ">'.__('Categories').'</a> |
         <a href="?module=fncatman&control=entropy">'.__('Groups').'</a> |
         <a href="?module=fncatman&control=shop">'.__('Shop').'</a> |
         <a href="?module=fncatalogue">'.__('Preview').'</a> |
         ';
      $controls.=fn_shop_notify_new_orders();
      show_window(__('Manage Catalogue'),$controls);
     }
    
    }

    function fn_cat_show_images($itemid,$full=true) {
        global $catconfig;
        $result='<table width="100%" border="0">';
        $itemid=vf($itemid,3);
        $query="SELECT * from `itemimg` where `itemid`='".$itemid."' ORDER BY `id`";
        $allimgs=simple_queryall($query);
        if (!empty ($allimgs)) {
            if ($full) {
            foreach ($allimgs as $io=>$eachimg) {
             $result.='
                 <tr>
                 <td>
                 <a href="'.$catconfig['images_path'].$eachimg['filename'].'" class="thickbox" rel="lightbox[photo]"><img src="'.$catconfig['images_path'].$eachimg['filename'].'" width="'.$catconfig['thumb_width'].'" title="'.$eachimg['desc'].'" border="0"></a>
                 </td>
                 </tr>';
             if (fncfr()) {
                $result.='
                 <tr>
                 <td align="right">
                 <a href="?module=fncatman&delitemimg='.$eachimg['id'].'"><img src="skins/fastnews/delete.gif" title="'.__('Delete').'" border="0"></a>
                 </td>
                 </tr>';
             }
            }
            } else {
              $result.='
                 <tr>
                 <td>
                 <a href="'.$catconfig['images_path'].$allimgs[0]['filename'].'" class="thickbox" rel="lightbox[photo]"><img src="'.$catconfig['images_path'].$allimgs[0]['filename'].'" width="'.$catconfig['thumb_width'].'" title="'.$allimgs[0]['desc'].'"></a>
                 </td>
                 </tr>';
          
            }
        }
        $result.='</table>';
        return($result);
    }

     function fn_cat_parse_item($item_arr,$full=true) {
       global $catconfig;
       if (!empty($catconfig['show_unavail'])) {
       if ($item_arr['avail']) {
                     $avail='';
                        } else {
                     $avail=' / '.__('Unavailable');
                        }
       } else {
            $avail='';
       }

       if (!empty($catconfig['show_avail'])) {
       if ($item_arr['avail']) {
                    $avail=' / '.__('Available');
                        } 
       }
     
       
       if ($full) {
         $itemtitle=$item_arr['name'];
       } else {
         $itemtitle='<a href="?module=fncatalogue&showitem='.$item_arr['id'].'">'.$item_arr['name'].'</a>';
       }
         $itemshorttext=$item_arr['short'];
         if ($full) {
             $itemfulltext=$item_arr['full'];
         } else {
             $itemfulltext='';
         }
          if (!empty ($item_arr['price'])) {
          $itemprice=__('Price').' '.$item_arr['price'];
         } else {
          $itemprice='';
         }

         if (!empty($catconfig['shop_inbody'])) {
           $shop_code=fn_cat_draw_shop($item_arr['id']);
          } else {
           $shop_code='';
          }
         

         $result='
             <table width="100%" border="0">
             <tr>
             <td valign="top" width="30%"></td>
             <td valign="top"><h2>'.$itemtitle.'</h2></td>
             </tr>
                 <tr>
             <td valign="top">'.fn_cat_show_images($item_arr['id'],$full).'</td>
             <td valign="top">
             '.$item_arr['short'].'<br>
             '.$itemfulltext.'
             <br>
             <br>
             <table width="100%" border="0">
             <tr>
             <td><h3 class="price">'.$itemprice.' '.$avail.'</h3></td>
             <td>'.$shop_code.'</td>
             </tr>
             </table>
             </td>
             </tr>
             </table>
             ';
         return($result);
     }

     function fn_cat_parse_item_thumb($item_arr,$full=true,$inheader) {
       global $catconfig;
       if (!empty($catconfig['show_unavail'])) {
       if ($item_arr['avail']) {
                     $avail='';
                        } else {
                     $avail=' / '.__('Unavailable');
                        }
       } else {
            $avail='';
       }

       if (!empty($catconfig['show_avail'])) {
       if ($item_arr['avail']) {
                    $avail=' / '.__('Available');
                        }
       }


       if ($full) {
         $itemtitle=$item_arr['name'];
       } else {
         $itemtitle='<a href="?module=fncatalogue&showitem='.$item_arr['id'].'">'.$item_arr['name'].'</a>';
       }
         $itemshorttext=$item_arr['short'];
         if ($full) {
             $itemfulltext=$item_arr['full'];
         } else {
             $itemfulltext='';
         }
          if (!empty ($item_arr['price'])) {
          $itemprice=__('Price').' '.$item_arr['price'];
         } else {
          $itemprice='';
         }

         if (!empty($catconfig['shop_inbody'])) {
           $shop_code=fn_cat_draw_shop($item_arr['id']);
          } else {
           $shop_code='';
          }


         $result='
             <table width="100%" border="0">
             <tr>
             <td valign="top" width="30%">'.$inheader.'</td>
             <td valign="top"><h2>'.$itemtitle.'</h2></td>
             </tr>
             <tr>
             <td valign="top">'.fn_cat_show_images($item_arr['id'],$full).'</td>
             <td valign="top">
             '.$item_arr['short'].'<br>
             '.$itemfulltext.'
             <br>
             <br>
             <table width="100%" border="0">
             <tr>
             <td><h3 class="price">'.$itemprice.' '.$avail.'</h3></td>
             <td>'.$shop_code.'</td>
             </tr>
             </table>
             </td>
             </tr>
             </table>
             ';
         return($result);
     }

    function fn_cat_showitem($itemid,$full=true) {
        global $catconfig;
        $query="SELECT * from `items` where `id`='".$itemid."'";
        $itembody=simple_query($query);
        if (!empty ($itembody)) {
        $result=fn_cat_parse_item($itembody,$full);
        if (fncfr ()) {
        $result.='
            <a href="?module=fnshoptag&itemid='.$itemid.'"><img src="skins/fastnews/tag_small.gif" title="'.__('Tag').'" border="0"></a> &nbsp;
            <a href="?module=fncatman&manageimg='.$itemid.'"><img src="skins/fastnews/images.gif" title="'.__('Image').'" border="0"></a> &nbsp;
            <a href="?module=fncatman&control=items&edititem='.$itemid.'"><img src="skins/fastnews/edit_small.gif" title="'.__('Edit').'" border="0"></a> &nbsp;
            <a href="?module=fncatman&deleteitem='.$itemid.'"><img src="skins/fastnews/trash_small.gif" title="'.__('Delete').'" border="0"></a><br>
            ';
        }
        if (empty($catconfig['shop_inbody'])) {
        $result.=fn_cat_draw_shop($itemid);
        }
        show_window('', $result);
        }
        
    }
     function fn_cat_showitem_thumb($itemid,$full=true) {
        global $catconfig;
        $query="SELECT * from `items` where `id`='".$itemid."'";
        $itembody=simple_query($query);
        if (!empty ($itembody)) {
        $result='';
        $inheader='';
        if (fncfr ()) {
        $inheader='
            <a href="?module=fnshoptag&itemid='.$itemid.'"><img src="skins/fastnews/tag_small.gif" title="'.__('Tag').'" border="0"></a> &nbsp;
            <a href="?module=fncatman&manageimg='.$itemid.'"><img src="skins/fastnews/images.gif" title="'.__('Image').'" border="0"></a> &nbsp;
            <a href="?module=fncatman&control=items&edititem='.$itemid.'"><img src="skins/fastnews/edit_small.gif" title="'.__('Edit').'" border="0"></a> &nbsp;
            <a href="?module=fncatman&deleteitem='.$itemid.'"><img src="skins/fastnews/trash_small.gif" title="'.__('Delete').'" border="0"></a><br>
            ';
        }
        $result.=fn_cat_parse_item_thumb($itembody,$full,$inheader);
        
        if (empty($catconfig['shop_inbody'])) {
        $result.=fn_cat_draw_shop($itemid);
        }
        return($result);
        }

    }

    function fn_cat_show_category_list() {
        global $catconfig;
        if ($catconfig['snowflake']==0) {
            $bullet='';
        }
        if ($catconfig['snowflake']==1) {
            $bullet='<img src="skins/fastnews/snowflake.gif" border="0">';
        }
        if ($catconfig['snowflake']==2) {
            $bullet='-';
        }
        $result='<table width="100%" border="0">';
        $query="SELECT * from `itemcat`";
        $allcats=simple_queryall($query);
        if (!empty($allcats)) {
        foreach ($allcats as $io=>$eachcat) {
          $result.='<tr>
                       <td width="20">
                       '.$bullet.'
                       </td>
                     <td>
                      <a href="?module=fncatalogue&showcat='.$eachcat['id'].'">'.$eachcat['name'].'</a> '.$eachcat['desc'].'
                     </td>
                    </tr>';
          }
        }
        $result.='</table>';
      show_window(__('Categories'), $result);
    }

     function fn_cat_getcatname($catid) {
         if (!empty ($catid)) {
         $query='SELECT `name` from `itemcat` WHERE `id`='.$catid;
         $result=simple_query($query);
         if (!empty ($result)) {
         return($result['name']);
         } else {
         return ('');
         }
         } else {
             return ('');
         }
     }

      function fn_cat_getcatdesc($catid) {
         if (!empty ($catid)) {
         $query='SELECT `desc` from `itemcat` WHERE `id`='.$catid;
         $result=simple_query($query);
         if (!empty ($result)) {
         return($result['desc']);
         } else {
         return ('');
         }
         } else {
             return ('');
         }
     }

    function fn_cat_show_category($catid,$page=1) {
        global $system,$catconfig;
        $page=vf($page,3);
        $catid=mysql_real_escape_string(vf($catid,3));
        $navlink='
            / <a href="?module=fncatalogue">'.__('Catalogue').'</a>
            / <a href="?module=fncatalogue&showcat='.$catid.'">'.fn_cat_getcatname($catid).'</a>
            ';
        $item_countq="SELECT COUNT(`id`) from `items` WHERE `catid`='".$catid."'";
        $item_count=simple_query($item_countq);
        $item_count=$item_count['COUNT(`id`)'];
        if ($catconfig['navlink']==1) {
        show_window('',$navlink);
        }
        if ($catconfig['navlink']==2) {
        $navlink=strip_tags($navlink);
        show_window('',$navlink);
        }
        $query="SELECT `id` from `items` WHERE `catid`='".$catid."' LIMIT ".($page-1)*$system->config['perpage'].','.$system->config['perpage'];
        $allitems=simple_queryall($query);
        if (!empty ($allitems)) {
            foreach ($allitems as $io=>$eachitem) {
                fn_cat_showitem($eachitem['id'], false);
                
            }
         show_window('',rcms_pagination($item_count, $system->config['perpage'], $page, '?module=fncatalogue&showcat='.$catid));
        }
    }  

     function fn_cat_show_category_thumb($catid,$page=1) {
        global $system,$catconfig;
        $page=vf($page,3);
        $inrow=$catconfig['thumb_list_inrow'];
        $counter=1;
        $rowcounter=1;
        $thumbs='<table width="100%" border="0"><tr>';
        $catid=mysql_real_escape_string(vf($catid,3));
        $result='';
        $navlink='
            / <a href="?module=fncatalogue">'.__('Catalogue').'</a>
            / <a href="?module=fncatalogue&showcat='.$catid.'">'.fn_cat_getcatname($catid).'</a>
            ';
        $item_countq="SELECT COUNT(`id`) from `items` WHERE `catid`='".$catid."'";
        $item_count=simple_query($item_countq);
        $item_count=$item_count['COUNT(`id`)'];
        if ($catconfig['navlink']==1) {
        show_window('',$navlink);
        }
        if ($catconfig['navlink']==2) {
        $navlink=strip_tags($navlink);
        show_window('',$navlink);
        }
        $query="SELECT `id` from `items` WHERE `catid`='".$catid."' LIMIT ".($page-1)*$system->config['perpage'].','.$system->config['perpage'];
        $allitems=simple_queryall($query);
        if (!empty ($allitems)) {
            foreach ($allitems as $io=>$eachitem) {
                  if ($rowcounter>$inrow) {
                  $thumbs.='</tr><tr>';
                  $rowcounter=1;
                  }
              
                $thumbs.='<td>'.fn_cat_showitem_thumb($eachitem['id'], false).'</td>';
            $rowcounter++;
            $counter++;
            }
            }
         $thumbs.='</tr></table>';
         show_window('',$thumbs);
         show_window('',rcms_pagination($item_count, $system->config['perpage'], $page, '?module=fncatalogue&showcat='.$catid));
        
    }

    function fn_cat_get_itemdata($itemid) {
     if (!empty ($itemid)) {
     $query="SELECT * from `items` where `id`=".$itemid;
     $result=simple_query($query);
     return ($result);
     }
    }

    function fn_cat_show_category_item($itemid) {
        global $catconfig;
        $itemid=vf($itemid,3);
        $itemdata=fn_cat_get_itemdata($itemid);
         $navlink='
            / <a href="?module=fncatalogue">'.__('Catalogue').'</a>
            / <a href="?module=fncatalogue&showcat='.$itemdata['catid'].'">'.fn_cat_getcatname($itemdata['catid']).'</a>
            / <a href="?module=fncatalogue&showitem='.$itemid.'">'.$itemdata['name'].'</a>
            ';
        if ($catconfig['navlink']==1) {
        show_window('',$navlink);
        }
        if ($catconfig['navlink']==2) {
        $navlink=strip_tags($navlink);
        show_window('',$navlink);
        }
        fn_cat_showitem($itemid);
    }

   function fn_cat_draw_shop($itemid) {
     global $catconfig;
     $result='';
     if (!empty($catconfig['enable_shop'])) {
     $result='
         <table width="100%" border="0">
         <tr>
         <td align="right">
         <table width="50%" border="0">
         <tr>
         <td align="right">
         <img src="skins/fastnews/shopping_cart.gif"> 
         </td>
         <td align="left">
         <form action="" method="POST">
         <input type="text" name="buycount" size="2" value="1">
         <input type="hidden" name="wanttobuy" value="'.$itemid.'">
         <input type="submit" value="'.__('Buy').'">
         </form>
         </td>
         </tr>
         </table>
         </td>
         </tr>
         </table>
         ';
     }
     if (empty($catconfig['guest_shop'])) {
     if (!LOGGED_IN) {
       $result='';
     }
     }
     return($result);
   }


   
   function fn_shop_generate_session() {
       global $system;
       $ip=$_SERVER['REMOTE_ADDR'];
       $ua=$_SERVER['HTTP_USER_AGENT'];
       $login=$system->user['username'];
       $lang=$_SERVER['HTTP_ACCEPT_LANGUAGE'];
       $unique_key=$ip.$ua.$login.$lang;
       $unique_key=strtoupper(md5($unique_key));
       return($unique_key);
   }

   function fn_shop_create_cart_buy($itemid,$count) {
       $session=fn_shop_generate_session();
       $timer=time();
       $itemid=vf($itemid,3);
       $count=vf($count,3);
       $query="
           INSERT INTO `itembuck` (
`id` ,
`session` ,
`timer` ,
`itemid` ,
`count`
)
VALUES (
'', '".$session."', '".$timer."', '".$itemid."', '".$count."'
);
 ";
      
       nr_query($query);
}

function fn_shop_show_cart($session) {
    global $catconfig;
$query="SELECT * FROM `itembuck` WHERE `session`='".$session."'";
$result='<h3>'.__('Your shopping cart is empty');
$allcart=simple_queryall($query);
$totalprice=0;
if (!empty($allcart)) {
    $result='<table width="100%" border="0">';
    $result.='
            <tr class="row1">
              <td>
              '.__('Item').'
              </td>
              <td>
              '.__('Price').'
              </td>
              <td>
              '.__('Quantity').'
              </td>
              <td>
              '.__('Total price').'
              </td>
              <td>
              '.__('Actions').'
              </td>
            </tr>
            ';
    foreach ($allcart as $io=>$eachitem) {
        $itemdata=fn_cat_get_itemdata($eachitem['itemid']);
        $result.='
            <tr class="row3">
              <td>
              <a href="?module=fncatalogue&showitem='.$itemdata['id'].'">'.$itemdata['name'].'</a>
              </td>
              <td>
              '.$itemdata['price'].'
              </td>
              <td>
              '.$eachitem['count'].'
              </td>
              <td>
              '.$itemdata['price']*$eachitem['count'].'
              </td>
              <td>
              <a href="?module=fncart&deletecartitem='.$eachitem['id'].'"><img src="skins/fastnews/trash_small.gif" border="0" title="'.__('Delete').'"></a>
              </td>
            </tr>
            ';
        $totalprice=$totalprice+($itemdata['price']*$eachitem['count']);
    }
    $result.='
          <tr class="row1">
              <td>

              </td>
              <td>

              </td>
              <td>

              </td>
              <td>
              <b>'.$totalprice.'</b>
              </td>
              <td>
              <a href="?module=fncart&flushcart=true">'.__('Flush').'</a>
              </td>
            </tr>
        ';
     $result.='</table>';
     $result.=fn_shop_delivery_form();
 }

 show_window(__('Shopping cart'), $result);

}

function fn_shop_is_my_cartitem($buckid) {
    $buckid=vf($buckid,3);
    $session=fn_shop_generate_session();
    $query="SELECT `timer` from `itembuck` WHERE `session`='".$session."' AND `id`='".$buckid."'";
    $rr=simple_query($query);
    if (!empty ($rr)) {
        return(true);
    } else {
        return (false);
    }
}

function fn_shop_deletecartitem($itemid) {
    $itemid=vf($itemid,3);
    $query="DELETE from `itembuck` WHERE `id`='".$itemid."'";
    if (fn_shop_is_my_cartitem($itemid)) {
        nr_query($query);
    }
     
}

function fn_shop_flushcart() {
    $session=fn_shop_generate_session();
    $query="DELETE from `itembuck` WHERE `session`='".$session."'";
    nr_query($query);
    
}

function fn_shop_show_cart_small($session) {
    global $catconfig;
$query="SELECT * FROM `itembuck` WHERE `session`='".$session."'";
$result='<h3>'.__('Your shopping cart is empty');
$allcart=simple_queryall($query);
$totalprice=0;
if (!empty($allcart)) {
    $result='<table width="100%" border="0">';
    
    foreach ($allcart as $io=>$eachitem) {
        $itemdata=fn_cat_get_itemdata($eachitem['itemid']);
        $result.='
            <tr class="row3">
              <td>
              <a href="?module=fncatalogue&showitem='.$itemdata['id'].'">'.$itemdata['name'].'</a>
              </td>
              <td>
              '.$itemdata['price'].'
             x
              '.$eachitem['count'].'
              </td>
    
            </tr>
            ';
        $totalprice=$totalprice+($itemdata['price']*$eachitem['count']);
    }
   
$result.='</table>';
$result.=__('Total').' '.$totalprice;
$result.='<br><a href="?module=fncart">'.__('Shopping cart').'</a>';
}
 show_window(__('Shopping cart'), $result);

}

function fn_shop_delivery_form() {
$result='
    <br>
    <br>
    <br>
    <h2>'.__('Request delivery').'</h2>
    <br>
    <form action="" method="POST">
    '.__('Real name').'<sup>*</sup><br>
    <input type="text" name="realname"><br>
    '.__('Email').'<sup>*</sup><br>
    <input type="text" name="email"><br>
    '.__('Phone').'<sup>*</sup><br>
    <input type="text" name="phone"><br>
   '.__('Address').'<sup>*</sup><br>
    <input type="text" name="address"><br>
    '.__('ICQ').'<br>
    <input type="text" name="icq"><br>
     '.__('Skype').'<br>
    <input type="text" name="skype"><br>
    '.__('Notes').'<br>
    <textarea name="notes" cols="50" rows="10"></textarea><br>
    <input type="hidden" name="delivery" value="true">
    <input type="submit" value="'.__('Request delivery').'">
    </form>
    ';
return($result);
}

function fn_cat_delitemimg($imageid) {
    global $catconfig;
    $imageid=vf($imageid,3);
    $query="SELECT * from `itemimg` WHERE `id`='".$imageid."'";
    $imagedata=simple_query($query);
    unlink($catconfig['images_path'].$imagedata['filename']);
    
    $query2="DELETE FROM `itemimg` WHERE `id`='".$imageid."'";
    nr_query($query2);
    rcms_redirect('?module=fncatman&manageimg='.$imagedata['itemid']);
}

function fn_cat_show_imgmanager($itemid) {
    $itemid=vf($itemid,3);
    $itemdata=fn_cat_get_itemdata($itemid);
    $result='<a href="?module=fncatman&control=items&edititem='.$itemid.'">'.__('Edit item').'</a><br><br>';
    //$result.='<h3>'.$itemdata['name'].'</h3> <br> '.$itemdata['full'];
    //$result.=fn_cat_show_images($itemid, true);
    
    $result.='
       <form enctype="multipart/form-data" action="?module=fncatman&manageimg='.$itemid.'" method="POST">
       <input type="hidden" name="upload_itemimg" value="true">
       <input type="hidden" name="MAX_FILE_SIZE" value="" />
       <input type="hidden" name="imgitemid" value="'.$itemid.'" />
       '.__('Select images to upload').'<sup>*</sup> <br> <input name="picload" type="file"/><br>
       '.__('Description').' <br> <input type="text" name="descimg" size="30"><br>
    <input type="submit" value="'.__('Upload images').'" />
    </form>
        ';
    show_window(__('Manage images'),$result);
    fn_cat_showitem($itemid);
}

function fn_cat_upload_itemimg($itemid) {
global $system;
global $catconfig;
$itemid=vf($itemid,3);
$siteurl=$system->url;
if ((isset($_POST['upload_itemimg'])) AND ($_POST['upload_itemimg']=="true")) {
$desc=$_POST['descimg'];
$newfilename=md5(time()).'.jpg';
$query="
INSERT INTO `itemimg` (
`id` ,
`itemid` ,
`filename` ,
`desc`
)
VALUES (
NULL , '".$itemid."', '".$newfilename."', '".$desc."'
);
";
nr_query($query);

$uploadfile = $catconfig['images_path'] . $newfilename;
if ((move_uploaded_file($_FILES['picload']['tmp_name'], $uploadfile))) {
     return $_FILES['picload']['name'];
  }
 }
}

function fn_cat_availselect ($itemid=0) {
    $itemid=vf($itemid,3);
     $flag='';
     $uflag='';
    if ($itemid) {
     $query="SELECT `avail` from `items` WHERE `id`='".$itemid."'";
     $avail=simple_query($query);
     
    } else {
        $avail['avail']=1;
    }
        $result='<select name="availsel">';
        if ($avail['avail']) {
            $flag='SELECTED';
            } else {
            $uflag='SELECTED';
            }
         $result.='<option value="1" '.$flag.'>'.__('Available').'</option>';
         $result.='<option value="0" '.$uflag.'>'.__('Unavailable').'</option>';
        

        $result.='</select>';
        return($result);
}


function fn_cat_show_itemcreate_form() {
    global $catconfig;
    if (!empty($catconfig['wysiwyg'])) {
        $tcm1='id="tmce1"';
        $tcm2='id="tmce2"';
    } else {
        $tcm1='';
        $tcm2='';
    }
    $form='
        <form action="" method="POST">
        '.__('Category').'<sup>*</sup><br>
        '.fn_cat_catselect().'<br>
        '.__('Item name').'<sup>*</sup><br>
        <input type="text" name="newitemname" size="40"><br>
        '.__('Short description').'<br>
        <textarea name="newshort" '.$tcm1.' cols="60" rows="10"></textarea><br>
        '.__('Full description').'<br>
        <textarea name="newfull"  '.$tcm2.' cols="60" rows="10"></textarea><br>
        '.__('Price').'<br>
        <input type="text" name="newitemprice" size="10"><br>
        '.__('Availability').'<sup>*</sup><br>
        '.fn_cat_availselect().'<br>
         <br>
        <input type="submit" value="'.__('Create item').'">
        </form>
        ';
    show_window(__('Create item'),$form);
}


function fn_cat_getlastitemid() {
    $query="SELECT `id` from `items` order by `id` DESC";
    $res=simple_query($query);
    return($res['id']);
}

function fn_cat_show_itemmodify_form($itemid) {
    global $catconfig;
      if ($catconfig['wysiwyg']) {
        $tcm1='id="tmce1"';
        $tcm2='id="tmce2"';
    } else {
        $tcm1='';
        $tcm2='';
    }
    $itemid=vf($itemid,3);
    $itemdata=fn_cat_get_itemdata($itemid);
    $form='
        <a href="?module=fncatman&manageimg='.$itemid.'">'.__('Manage images').'</a> |
        <a href="?module=fncatman&deleteitem='.$itemid.'">'.__('Delete').'</a> |
        <a href="?module=fncatalogue&showitem='.$itemid.'">'.__('Preview').'</a> |
        <br><br>
        <form action="" method="POST">
        '.__('Category').'<sup>*</sup><br>
        '.fn_cat_catselect().'<br>
        '.__('Item name').'<sup>*</sup><br>
        <input type="text" name="moditemname" size="40" value="'.$itemdata['name'].'"><br>
        '.__('Short description').'<br>
        <textarea name="modshort" '.$tcm1.' cols="60" rows="10">'.$itemdata['short'].'</textarea><br>
        '.__('Full description').'<br>
        <textarea name="modfull" '.$tcm2.' cols="60" rows="10">'.$itemdata['full'].'</textarea><br>
        '.__('Price').'<br>
        <input type="text"  name="moditemprice" size="10" value="'.$itemdata['price'].'"><br>
        '.__('Availability').'<sup>*</sup><br>
        '.fn_cat_availselect($itemid).'<br>
         <br>
        <input type="submit" value="'.__('Edit').'">
        </form>
        ';

    show_window(__('Edit'),$form);
}

function fn_cat_create_item($catid,$name,$short,$full,$price,$avail) {
    global $catconfig;
    $catid=vf($catid,3);
    $name=mysql_real_escape_string($name);
    $short=mysql_real_escape_string($short);
    $full=mysql_real_escape_string($full);
    $price=mysql_real_escape_string($price);
    $query="
        INSERT INTO `items` (
`id` ,
`catid` ,
`name` ,
`short` ,
`full` ,
`mode` ,
`price` ,
`avail`
)
VALUES (
NULL , '".$catid."', '".$name."', '".$short."', '".$full."', NULL , '".$price."', '".$avail."'
);
 ";
    nr_query($query);
    deb($query);
    $new_id=fn_cat_getlastitemid();
    if ($catconfig['after_create']==1) {
    rcms_redirect('?module=fncatman&control=items&edititem='.$new_id);
    }
    if ($catconfig['after_create']==2) {
    rcms_redirect('?module=fncatman&manageimg='.$new_id);
    }
}


function fn_cat_deleteitem($itemid) {
    $itemid=vf($itemid,3);
    $query="DELETE from `items` WHERE `id`='".$itemid."'";
    $query2="DELETE from `itemimg` WHERE `itemid`='".$itemid."'";
    nr_query($query);
    nr_query($query2);
 }


 function fn_cat_modifyitem($itemid,$catid,$name,$short,$full,$price,$avail) {
    $catid=vf($catid,3);
    $itemid=vf($itemid,3);
    $name=mysql_real_escape_string($name);
    $short=mysql_real_escape_string($short);
    $full=mysql_real_escape_string($full);
    $price=mysql_real_escape_string($price);
    $query="
        UPDATE `items` SET 
        `catid` = '".$catid."',
        `name` = '".$name."',
        `short` = '".$short."',
        `full` = '".$full."',
        `price` = '".$price."',
        `avail` = '".$avail."'
        WHERE `id` ='".$itemid."';
        ";
    nr_query($query);
    
 }

 function fn_shop_getlastdelivery() {
    $query="SELECT `id` from `itemshop` order by `id` DESC";
    $res=simple_query($query);
    return($res['id']);
}

 function fn_shop_create_itembuy($realname,$email,$phone, $address, $icq='',$skype='',$notes='') {
     global $system;
     $items=array();
     $date=date("Y-m-d H:i:s");
     $session=fn_shop_generate_session();
     $ip=$_SERVER['REMOTE_ADDR'];
     $login=$system->user['username'];
     $realname=mysql_real_escape_string(strip_tags($realname));
     $email=mysql_real_escape_string(strip_tags($email));
     $phone=mysql_real_escape_string(strip_tags($phone));
     $address=mysql_real_escape_string(strip_tags($address));
     $icq=mysql_real_escape_string(strip_tags($icq));
     $skype=mysql_real_escape_string(strip_tags($skype));
     $notes=mysql_real_escape_string(strip_tags($notes));
     $goods_q="SELECT * from `itembuck` WHERE `session`='".$session."'";
     $goods=simple_queryall($goods_q);
     if (!empty ($goods)) {
        
        foreach ($goods as $io=>$each_good) {
            $items[$each_good['itemid']]=$each_good['count'];
        }

        $serial_items=serialize($items);
        $query="
            INSERT INTO `itemshop` (
                `id` ,
                `date` ,
                `session` ,
                `realname` ,
                `email` ,
                `phone` ,
                `address` ,
                `icq` ,
                `skype` ,
                `notes` ,
                `login` ,
                `ip` ,
                `items`,
                `state`
                )
                VALUES (
               NULL ,
               '".$date."',
                   '".$session."',
                       '".$realname."',
                           '".$email."',
                               '".$phone."',
                                   '".$address."',
                                   '".$icq."',
                                       '".$skype."',
                                           '".$notes."',
                                               '".$login."',
                                                   '".$ip."',
                                                       '".$serial_items."',
                                                           'processing'
                                                           );
            ";
       
     nr_query($query);
     $delivery_id=fn_shop_getlastdelivery();
     $complete=__('Your order has been received and is awaiting processing. Number of your order is').' - <b>'.$delivery_id.'</b>. '.__('You need it to track the state of your order.');
     show_window(__('Order received'),$complete);
     fn_shop_flushcart();
     } else {
         //   =)
         show_error(__('No goods for sale'));
     }
  }

function fn_shop_show_orders() {
    $query="SELECT * FROM `itemshop` order by `id`";
    $allorders=simple_queryall($query);
    $result='<table width="100%" border="0">';
    if (!empty ($allorders)) {
        $result.='
         <tr class="row1">
            <td>
            '.__('Order').'
            </td>
            <td>
             '.__('Date').'
            </td>
            <td>
             '.__('Real name').'
            </td>
            <td>
             '.__('State').'
            </td>
             <td>
             '.__('Actions').'
            </td>
         </tr>
         ';
    
    foreach ($allorders as $io=>$eachorder) {
     $result.='
         <tr class="row3">
            <td>
            <a href="?module=fncatman&control=shop&showorder='.$eachorder['id'].'">'.$eachorder['id'].'</a>
            </td>
            <td>
             <a href="?module=fncatman&control=shop&showorder='.$eachorder['id'].'">'.$eachorder['date'].'</a>
            </td>
            <td>
            <a href="?module=fncatman&control=shop&showorder='.$eachorder['id'].'"> '.$eachorder['realname'].'</a>
            </td>
            <td>
             <a href="?module=fncatman&control=shop&showorder='.$eachorder['id'].'">'.__($eachorder['state']).'</a>
            </td>
             <td>
             <a href="?module=fncatman&control=shop&deleteorder='.$eachorder['id'].'"><img src="skins/fastnews/trash_small.gif" title="'.__('Delete').'" border="0"></a>
             <a href="?module=fncatman&control=shop&showorder='.$eachorder['id'].'"><img src="skins/fastnews/view.gif" title="'.__('Edit').'" border="0"></a>
            </td>
         </tr>
         ';
     
    }
    
    }
   $result.='</table>';
    show_window(__('Orders'),$result);
}

function fn_shop_get_orderdata($order_id) {
    $order_id=vf($order_id,3);
    $query="SELECT * from `itemshop` WHERE `id`='".$order_id."'";
    $result=simple_query($query);
    return($result);
}

function fn_cat_check_avail($state) {
    if ($state) {
        return (__('Available'));
    } else {
        return (__('Unavailable'));
    }
}

function fn_shop_show_order($order_id) {
   $order_id=vf($order_id,3);
   $order_data=fn_shop_get_orderdata($order_id);
   $result='<table width="100%" border="0">';
   $result.='
           <tr class="row3">
           <td>
           '.__('Order').'
           </td>
           <td>
          <acronym title="'.$order_data['session'].'">'.$order_data['id'].'</acronym>
           </td>
           </tr>
           
           <tr class="row3">
           <td>
            '.__('Date').'
           </td>
           <td>
           '.$order_data['date'].'
           </td>
           </tr>

          <tr class="row3">
           <td>
            '.__('Real name').'
           </td>
           <td>
           '.$order_data['realname'].'
           </td>
           </tr>

           <tr class="row3">
           <td>
            '.__('Email').'
           </td>
           <td>
           '.$order_data['email'].'
           </td>
           </tr>


           <tr class="row3">
           <td>
            '.__('Phone').'
           </td>
           <td>
           '.$order_data['phone'].'
           </td>
           </tr>


           <tr class="row3">
           <td>
            '.__('ICQ').'
           </td>
           <td>
           '.$order_data['icq'].'
           </td>
           </tr>


           <tr class="row3">
           <td>
            '.__('Skype').'
           </td>
           <td>
           '.$order_data['skype'].'
           </td>
           </tr>


           <tr class="row3">
           <td>
            '.__('Address').'
           </td>
           <td>
           '.$order_data['address'].'
           </td>
           </tr>
           
            <tr class="row3">
           <td>
            '.__('Username').'
           </td>
           <td>
           '.$order_data['login'].'
           </td>
           </tr>

            <tr class="row3">
           <td>
            '.__('IP').'
           </td>
           <td>
           '.$order_data['ip'].'
           </td>
           </tr>

             <tr class="row3">
           <td>
            '.__('State').'
           </td>
           <td>
           '.__($order_data['state']).'
           </td>
           </tr>


           <tr class="row3">
           <td>
            '.__('Notes').'
           </td>
           <td>
           '.$order_data['notes'].'
           </td>
           </tr>
           ';
  $result.='</table>';
  $order_b='<table width="100%" border="0">';
  $item_buck=unserialize($order_data['items']);
  $tsum=0;
  $order_b.='
      <tr class="row1">
      <td>'.__('Item name').'</td>
      <td>'.__('Availability').'</td>
      <td>'.__('Price').'</td>
      <td>'.__('Quantity').'</td>
      <td>'.__('Total').'</td>
      </tr>
      ';
  foreach ($item_buck as $item=>$count) {
  $item_data=fn_cat_get_itemdata($item);
  $summ=$item_data['price']*$count;
  $tsum=$tsum+$summ;
  $order_b.='
      <tr class="row2">
      <td><a href="?module=fncatalogue&showitem='.$item_data['id'].'">'.$item_data['name'].'</a></td>
      <td>'.fn_cat_check_avail($item_data['avail']).'</td>
      <td>'.$item_data['price'].'</td>
      <td>'.$count.'</td>
      <td>'.$summ.'</td>
      </tr>
      ';
  }
  $order_b.='</table>';
  $order_b.='<h3>'.__('Order amount').': '.$tsum.'</h3>';
  show_window(__('Order'), $result);
  show_window(__('Items'), $order_b);
  show_window(__('State'),fn_shop_state_changer_form($order_id));
}

function fn_shop_delete_order($order_id) {
    $order_id=vf($order_id,3);
    $query="DELETE from `itemshop` where `id`='".$order_id."'";
    nr_query($query);
}


function fn_shop_state_changer_form($orderid) {
    $form='
        <form action="?module=fncatman&control=shop&showorder='.$orderid.'" method="POST">
        <select name="itemstatemod">
        <option value="processing">'.__('processing').'</option>
        <option value="awaiting payment">'.__('awaiting payment').'</option>
        <option value="rejected">'.__('rejected').'</option>
        <option value="sent to the recipient">'.__('sent to the recipient').'</option>
        </select>
        <input type="submit" value="'.__('Save').'">
        </form>
        ';
    return($form);
}


function fn_shop_state_change($orderid,$state) {
    $query="UPDATE `itemshop` SET `state` = '".$state."' WHERE `id` ='".$orderid."';";
    nr_query($query);
  }


  function fn_shop_notify_new_orders() {
      global $catconfig;
      $result='';
      if (!empty($catconfig['newordernotify'])) {
      if (fncfr()) {
    $query="SELECT COUNT(`id`) FROM `itemshop` WHERE `state`='processing'";
    $newordercount=simple_query($query);
    $newordercount=$newordercount['COUNT(`id`)'];
    if ($newordercount>0) {
        $result='<b><a href="?module=fncatman&control=shop">'.$newordercount.' '.__('new orders awaiting moderation').'</a></b>';
    }
    return($result);

      }
     }
  }

  function fn_shop_show_trackform() {
      $form='
          <form action="?module=fnshoptrack" method="POST">
           <input type="text" name="trackmail" size="20"> '.__('Email').'<sup>*</sup><br>
           <input type="text" name="trackorder" size="20"> '.__('Order').'<sup>*</sup><br>
           <input type="submit" value="'.__('Order track').'">
          </form>
          ';
      show_window(__('Order track'), $form);
  }

  function fn_shop_track_order($order_id,$email) {
      $order_id=vf($order_id,3);
      $email=mysql_real_escape_string($email);
      if ((!empty ($email)) AND (!empty ($order_id))) {
      $orderdata=fn_shop_get_orderdata($order_id);
      if (!empty ($orderdata)) {
          $result='
              <table width="100%" border="0">
                <tr class="row3">
                 <td>
                    '.__('Order').'
                 </td>
                 <td>
                    '.$orderdata['id'].'
                 </td>
                </tr>
                <tr class="row3">
                 <td>
                    '.__('Real name').'
                 </td>
                 <td>
                    '.$orderdata['realname'].'
                 </td>
                </tr>
                <tr class="row3">
                 <td>
                    '.__('Email').'
                 </td>
                 <td>
                    '.$orderdata['email'].'
                 </td>
                </tr>
                <tr class="row3">
                 <td>
                    '.__('Phone').'
                 </td>
                 <td>
                    '.$orderdata['phone'].'
                 </td>
                </tr>
                <tr class="row3">
                 <td>
                    '.__('State').'
                 </td>
                 <td>
                    '.__($orderdata['state']).'
                 </td>
                </tr>
             </table>
              ';
          show_window('', $result);
       }
      }
      
  }

  function fn_cat_show_cateditform($catid) {
      $catid=vf($catid,3);
      $catname=fn_cat_getcatname($catid);
      $catdesc=fn_cat_getcatdesc($catid);
      $form='
          <form action="?module=fncatman&editcat='.$catid.'" method="POST">
             <input type="text" name="editcatname" value="'.$catname.'" size="30"> '.__('Title').'<sup>*</sup> <br>
             <input type="text" name="editcatdesc" value="'.$catdesc.'" size="30"> '.__('Description').' <br>
             <input type="submit" value="'.__('Save').'">
          </form>
          ';
    show_window(__('Edit'), $form);
  }

  function fn_cat_modify($catid,$name,$desc) {
      $catid=vf($catid,3);
      $name=mysql_real_escape_string(strip_tags($name));
      $desc=mysql_real_escape_string(strip_tags($desc));
      $query1="UPDATE `itemcat` SET `name` = '".$name."' WHERE `id` = '".$catid."'";
      $query2="UPDATE `itemcat` SET `desc` = '".$desc."' WHERE `id` = '".$catid."'";
      nr_query($query1);
      nr_query($query2);
  }

  function fn_show_entropy_panel() {
      if (fncfr()) {
      $panel='
         <a href="?module=fncatman&control=entropy&entropyedit=true">'.__('Edit').'</a> |
         <a href="?module=fnentropy">'.__('Preview').'</a> |
          ';
      show_window(__('Groups'), $panel);
      }
  }

function fn_entropy_show_upcat($subcats) {
global $catconfig;
$result='<table width="100%" border="0">';
 if ($catconfig['snowflake']==0) {
            $bullet='';
        }
        if ($catconfig['snowflake']==1) {
            $bullet='<img src="skins/fastnews/snowflake.gif" border="0">';
        }
        if ($catconfig['snowflake']==2) {
            $bullet='-';
        }
          
if (!empty ($subcats)) {
     foreach ($subcats as $io=>$subcat) {
              $subname=fn_cat_getcatname($subcat);
              if (!empty ($subname)) {
              $result.='<tr>
                  <td width="20">
                  '.$bullet.'
                  </td>
                  <td>
                  <a href="?module=fncatalogue&showcat='.$subcat.'">'.$subname.'</a>
                  </td>
                  </tr>';
        
      }
    }
}
$result.='</table>';
show_window('', $result);
}

function fn_entropy_show_upcat_list($upcats) {
global $catconfig;
$result='<table width="100%" border="0">';
 if ($catconfig['snowflake']==0) {
            $bullet='';
        }
        if ($catconfig['snowflake']==1) {
            $bullet='<img src="skins/fastnews/snowflake.gif" border="0">';
        }
        if ($catconfig['snowflake']==2) {
            $bullet='-';
        }

    if (!empty ($upcats)) {
        foreach ($upcats as $upcat_id=>$upcat_name) {
           $result.='<tr>
                  <td width="20">
                  '.$bullet.'
                  </td>
                  <td>
                  <a href="?module=fnentropy&showupcat='.$upcat_name['id'].'">'.$upcat_name['name'].'</a> '.$upcat_name['desc'].'
                  </td>
                  </tr>';
           }
    }
    $result.='</table>';

   show_window('', $result);

}


  function fn_show_entropy_create_form() {
      $form='<form action="?module=fncatman&control=entropy&entropyedit=true" method="POST">
           <input name="newentname" type="text" size="30"> '.__('Title').' <sup>*</sup> <br>
           <input name="newentdesc" type="text" size="30"> '.__('Description').'  <br>
           <input type="submit" value="'.__('Save').'">
          </form>';
      show_window(__('Create'),$form);
  }



  function fn_entropy_load ($upcat_id) {
      $upcat_id=vf($upcat_id,3);
      $query="SELECT `subcat` from `entropy` where `upcat`='".$upcat_id."'";
      $allupcat=simple_queryall($query);
      $entropy=array();
      if (!empty ($allupcat)) {
           foreach ($allupcat as $io=>$eachsub) {
            $entropy[]=$eachsub['subcat'];
            }
           }
        
          return ($entropy);
  }

    function fn_upcat_load () {
      $query="SELECT * from `itemupcat`";
      $allupcat=simple_queryall($query);
      $entropy=array();
      if (!empty ($allupcat)) {
           foreach ($allupcat as $io=>$eachup) {
            $entropy[$io]=$eachup;
            }
           }
       
         return ($entropy);
  }

   function fn_cat_upcatselect() {
        $query="SELECT `id`,`name` from `itemupcat`";
        $allupcats=simple_queryall($query);
        $result='<select name="upcatsel">';
        if (!empty ($allupcats)) {
        foreach ($allupcats as $io=>$eachupcat) {
              $result.='<option value="'.$eachupcat['id'].'" >'.$eachupcat['name'].'</option>';
            }
        }

        $result.='</select>';
        return($result);
    }
  function fn_show_entropy_edit_form() {
    $query="SELECT * from `itemupcat`";
    $upcats=simple_queryall($query);
    $form='
            <table width="100%" border="0">';
    if (!empty ($upcats)) {
        foreach ($upcats as $upcat_id=>$upcats) {
          $form.='
                <tr class="row2">
                <td>
                <a href="?module=fncatman&control=entropy&entropyedit=true&deleteupcat='.$upcats['id'].'" ><img src="skins/fastnews/trash_small.gif" border="0" title="'.__('Delete').'"></a>
                </td>
                <td>
                 '.$upcats['name'].'
                </td>
                 <td>
               
                </td>
                </tr>';
              $sub_q="SELECT * from `entropy` WHERE `upcat`='".$upcats['id']."'";
              $subcats=simple_queryall($sub_q);
              if (!empty ($subcats)) {
                   foreach ($subcats as $io=>$eachsub) {
                      $subname=fn_cat_getcatname($eachsub['subcat']);
                      $form.='
                <tr class="row1">
                <td>
                </td>
                <td>
               
                </td>
                <td>
                 <a href="?module=fncatman&control=entropy&entropyedit=true&deletesubcat='.$eachsub['id'].'" ><img src="skins/fastnews/trash_small.gif" border="0" title="'.__('Delete').'"></a>
                 '.$subname.'
                </td>
                </tr>
               ';
                  }
              }
          
        }
    }
 
                
    $form.='<form action="?module=fncatman&control=entropy&entropyedit=true" method="POST">
        <input type="hidden" name="newentropy" value="true">
         <tr class="row1">
                <td>
                </td>
                <td>
               '.fn_cat_upcatselect().'
                </td>
                <td>
                '.fn_cat_catselect().'
                <input type="submit" value="'.__('Save').'">
                </td>
                </tr>
            
            </form> ';
   $form.='</table>';
    show_window(__('Edit'),$form);
  }

  function fn_entropy_deleteupcat($upcat_id) {
  $upcat_id=vf($upcat_id,3);
  $query="DELETE FROM `itemupcat` WHERE `id`='".$upcat_id."'";
  $query2="DELETE FROM `entropy` WHERE `upcat`='".$upcat_id."'";
  nr_query($query);
  nr_query($query2);
  rcms_redirect("?module=fncatman&control=entropy&entropyedit=true");
  }

   function fn_entropy_deletesubcat($subcat_id) {
  $subcat_id=vf($subcat_id,3);
  $query="DELETE FROM `entropy` WHERE `id`='".$subcat_id."'";
  nr_query($query);
  rcms_redirect("?module=fncatman&control=entropy&entropyedit=true");
  }

  function fn_entropy_createupcat($name,$desc) {
      $name=mysql_real_escape_string($name);
      $desc=mysql_real_escape_string($desc);
      $query="
          INSERT INTO `itemupcat` (
`id` ,
`name` ,
`desc`
)
VALUES (
NULL , '".$name."', '".$desc."'
);
    ";
      nr_query($query);
      rcms_redirect("?module=fncatman&control=entropy&entropyedit=true");
  }

  function fn_entropy_create($upcat_id,$subcat_id) {
      $query="INSERT INTO `entropy` (
          `id`,
          `upcat`,
          `subcat`  )
          VALUES (
          NULL, '".$upcat_id."','".$subcat_id."'
          )
          ";
      nr_query($query);
      rcms_redirect("?module=fncatman&control=entropy&entropyedit=true");
  }

?>